//  Пример взят с сайта http://homes-smart.ru/index.php/oborudovanie/bez-provodov-433-315mgts/45-odin-iz-algoritmov-peredachi-dannykh-v-vide-tsifrovogo-koda
//


// Access from ARM Running Linux

#define BCM2708_PERI_BASE        0x20000000
#define GPIO_BASE                (BCM2708_PERI_BASE + 0x200000) /* GPIO controller */


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dirent.h>
#include <fcntl.h>
#include <assert.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <bcm2835.h>
#include <unistd.h>


int main(int argc, char **argv)
{
 if (!bcm2835_init())
       return 1;

 if (argc != 3) {
       printf("usage: %s <ключ> <gpio>#\n", argv[0]);
       return 2;
 }
int key = atoi(argv[1]);


 int pin = atoi(argv[2]);

 if (pin <= 0) {
       printf("Please select a valid GPIO pin #\n");
       return 3;
 }


rcsend(key, pin);
 return 0;

} // main



int rcsend(unsigned long data, int pin) {
 // Set GPIO pin to output
 bcm2835_gpio_fsel(pin, BCM2835_GPIO_FSEL_OUTP);
  unsigned int periodusec=400; // тут задается период !

  
    data |= 3L << 20;
    
	unsigned short repeats = 1 << (((unsigned long)data >> 20) & 7);
	data = data & 0xfffff;
		
	unsigned long dataBase4 = 0;
	unsigned short i;
	
	for (i=0; i<12; i++) {
		dataBase4<<=2;
		dataBase4|=(data%3);
		data/=3;
	}
	unsigned short int j;
	for (j=0;j<repeats;j++) {		

		data=dataBase4;
		
		unsigned short i;
		for (i=0; i<12; i++) {
			switch (data & 3) {
				case 0:
					bcm2835_gpio_write(pin, 1);		
					usleep(periodusec);
					bcm2835_gpio_write(pin, 0);
					usleep(periodusec*3);
					bcm2835_gpio_write(pin, 1);
					usleep(periodusec);
					bcm2835_gpio_write(pin, 0);
					usleep(periodusec*3);
					break;
				case 1:
					bcm2835_gpio_write(pin, 1);
					usleep(periodusec*3);
					bcm2835_gpio_write(pin, 0);
					usleep(periodusec);
					bcm2835_gpio_write(pin, 1);
					usleep(periodusec*3);
					bcm2835_gpio_write(pin, 0);
					usleep(periodusec);
					break;
				case 2:
					bcm2835_gpio_write(pin, 1);
					usleep(periodusec);
					bcm2835_gpio_write(pin, 0);
					usleep(periodusec*3);
					bcm2835_gpio_write(pin, 1);
					usleep(periodusec*3);
					bcm2835_gpio_write(pin, 0);
					usleep(periodusec);
					break;
			}
			data>>=2;
		}
		
		bcm2835_gpio_write(pin, 1);
		usleep(periodusec);
		bcm2835_gpio_write(pin, 0);
		usleep(periodusec*31);
	}
 
 
 
 return 0;
}